<xsl:stylesheet version = "1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                >

  <xsl:output method="text" />

  <xsl:param name="quiet"   >no</xsl:param>
  <xsl:param name="added"   >yes</xsl:param> 
  <xsl:param name="modified">yes</xsl:param> 
  <xsl:param name="removed" >yes</xsl:param> 


  <xsl:template match="diff">
    <xsl:if test="$added = 'yes'">
      <xsl:call-template name="count-layer">
	<xsl:with-param name="nodes" select="added[not(overlap)]" />
	<xsl:with-param name="layer">Added</xsl:with-param>
	<xsl:with-param name="quiet" select="$quiet" />
      </xsl:call-template>
    </xsl:if>
    <xsl:if test="$modified = 'yes'">
      <xsl:call-template name="count-layer">
	<xsl:with-param name="nodes" select="added[overlap]" />
	<xsl:with-param name="layer">Modified</xsl:with-param>
	<xsl:with-param name="quiet" select="$quiet" />
      </xsl:call-template>
    </xsl:if>
    <xsl:if test="$removed = 'yes'">
      <xsl:call-template name="count-layer">
	<xsl:with-param name="nodes" select="removed" />
	<xsl:with-param name="layer">Removed</xsl:with-param>
	<xsl:with-param name="quiet" select="$quiet" />
      </xsl:call-template>
    </xsl:if>
    <xsl:if test="$quiet = 'yes'">
      <xsl:text>
</xsl:text>
    </xsl:if>
  </xsl:template>

  <xsl:template name="count-layer">
    <xsl:param name="nodes" />
    <xsl:param name="layer" />
    <xsl:param name="quiet">no</xsl:param>
    <xsl:choose>
      <xsl:when test="$quiet != 'yes'">
	<xsl:value-of select="$layer" /><xsl:text>: </xsl:text><xsl:value-of select="count($nodes)" /><xsl:text>
</xsl:text>
      </xsl:when>
      <xsl:otherwise>
<xsl:value-of select="count($nodes)" /><xsl:text>	</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>