<xsl:stylesheet version = "1.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:a="http://alvis.info/enriched/"
		>

  <xsl:variable name="reference-set" select="document($reference-file)//a:named_entity" />
  <xsl:variable name="derived-set" select="//a:named_entity" />

  <xsl:template match="/">
    <xsl:element name="diff">
      <xsl:for-each select="$derived-set">
	<xsl:variable name="right-node" select="." />
	<xsl:if test="not($reference-set/a:id=$right-node/a:id)">
	  <xsl:element name="added">
	    <xsl:attribute name="id"><xsl:value-of select="$right-node/a:id" /></xsl:attribute>

	    <xsl:for-each select="$right-node/a:list_refid_token/a:refid_token">
	      <xsl:variable name="right-token" select="." />
	      <xsl:for-each select="$reference-set">
		<xsl:if test="./a:list_refid_token[a:refid_token=$right-token]">
		  <xsl:element name="overlap"><xsl:attribute name="id"><xsl:value-of select="./a:id" /></xsl:attribute></xsl:element>
		</xsl:if>
	      </xsl:for-each>
	    </xsl:for-each>

	  </xsl:element>
	</xsl:if>
      </xsl:for-each>
      
      <xsl:for-each select="$reference-set">
	<xsl:variable name="left-node" select="." />

	<xsl:if test="not($derived-set/a:id=./a:id)">

	  <xsl:variable name="overlaps">
	    <xsl:for-each select="$left-node/a:list_refid_token/a:refid_token">
	      <xsl:variable name="left-token" select="." />
	      <xsl:for-each select="$derived-set">
		<xsl:if test="./a:list_refid_token[a:refid_token=$left-token]">
		  <xsl:element name="overlap"><xsl:value-of select="./a:id" /></xsl:element>
		</xsl:if>
	      </xsl:for-each>
	    </xsl:for-each>
	  </xsl:variable>

	  <xsl:if test="$overlaps=''">
	    <xsl:element name="removed">
	      <xsl:variable name="first-token" select="./a:list_refid_token/a:refid_token[1]" />
	      <xsl:attribute name="id"><xsl:value-of select="./a:id" /></xsl:attribute>
	      <xsl:attribute name="word_id"><xsl:value-of select="//a:word[a:list_refid_token/a:refid_token=$first-token]/a:id" /></xsl:attribute>
	    </xsl:element>
	  </xsl:if>
	</xsl:if>
      </xsl:for-each>
    </xsl:element>
  </xsl:template>
</xsl:stylesheet>