#!/usr/bin/perl

use strict;
use Getopt::Long;

my $SEPARATOR = "[^0-9]+";
my $CUMUL = 0;

sub usage {
    print "Usage: $0 [OPTIONS]\n";
    print "Sums colons in afile\n";
}

if (grep(/help|aide| -h/,@ARGV)) {
    usage();
    exit;
}

GetOptions(
           "separator|s=s" => \$SEPARATOR,
	   "cumulative|c" => \$CUMUL
	   );

my @SUM = ();

while (my $l = <STDIN>) {
    chomp $l;
    my @n = split(/$SEPARATOR/,$l);
    foreach my $i (0 .. $#n) {
	if ($n[$i] =~ /([0-9]+)/) {
	    $SUM[$i] += int($1);
	    if ($CUMUL) {
		if ($i > 0) {
		    print "\t";
		}
		print $SUM[$i];
	    }
	}
    }
    if ($CUMUL) {
	print "\n";
    }
}

if (!$CUMUL) {
    foreach my $i (0 .. $#SUM) {
	if ($i > 0) {
	    print "\t";
	}
	print $SUM[$i];
    }
    print "\n";
}
